
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Checklist_run_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const checklist_run_items = await db.checklist_run_items.create(
            {
                id: data.id || undefined,
        
        is_done: data.is_done
        ||
        false
        
            ,
            
        comment: data.comment
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await checklist_run_items.setChecklist_run( data.checklist_run || null, {
            transaction,
        });
        
        await checklist_run_items.setChecklist_item( data.checklist_item || null, {
            transaction,
        });
        
        await checklist_run_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.checklist_run_items.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: checklist_run_items.id,
            },
            data.photos,
            options,
        );
        

        return checklist_run_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const checklist_run_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                is_done: item.is_done
            ||
            false
        
            ,
            
                comment: item.comment
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const checklist_run_items = await db.checklist_run_items.bulkCreate(checklist_run_itemsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < checklist_run_items.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.checklist_run_items.getTableName(),
                    belongsToColumn: 'photos',
                    belongsToId: checklist_run_items[i].id,
                },
                data[i].photos,
                options,
            );
        }
        

        return checklist_run_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const checklist_run_items = await db.checklist_run_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.is_done !== undefined) updatePayload.is_done = data.is_done;
        
        
        if (data.comment !== undefined) updatePayload.comment = data.comment;
        
        
        updatePayload.updatedById = currentUser.id;

        await checklist_run_items.update(updatePayload, {transaction});

        
        
        if (data.checklist_run !== undefined) {
            await checklist_run_items.setChecklist_run(
              
              data.checklist_run,
              
              { transaction }
            );
        }
        
        if (data.checklist_item !== undefined) {
            await checklist_run_items.setChecklist_item(
              
              data.checklist_item,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await checklist_run_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.checklist_run_items.getTableName(),
                belongsToColumn: 'photos',
                belongsToId: checklist_run_items.id,
            },
            data.photos,
            options,
        );
        

        return checklist_run_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const checklist_run_items = await db.checklist_run_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of checklist_run_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of checklist_run_items) {
                await record.destroy({transaction});
            }
        });


        return checklist_run_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const checklist_run_items = await db.checklist_run_items.findByPk(id, options);

        await checklist_run_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await checklist_run_items.destroy({
            transaction
        });

        return checklist_run_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const checklist_run_items = await db.checklist_run_items.findOne(
            { where },
            { transaction },
        );

        if (!checklist_run_items) {
            return checklist_run_items;
        }

        const output = checklist_run_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.checklist_run = await checklist_run_items.getChecklist_run({
            transaction
        });
        
        
        output.checklist_item = await checklist_run_items.getChecklist_item({
            transaction
        });
        
        
        output.photos = await checklist_run_items.getPhotos({
            transaction
        });
        
        
        output.organizations = await checklist_run_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.checklist_runs,
        as: 'checklist_run',
        
        where: filter.checklist_run ? {
          [Op.or]: [
            { id: { [Op.in]: filter.checklist_run.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.checklist_run.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.checklist_items,
        as: 'checklist_item',
        
        where: filter.checklist_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.checklist_item.split('|').map(term => Utils.uuid(term)) } },
            {
              item_text: {
                [Op.or]: filter.checklist_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'photos',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.comment) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'checklist_run_items',
                        'comment',
                        filter.comment,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_done) {
                where = {
                    ...where,
                is_done: filter.is_done,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.checklist_run_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'checklist_run_items',
                        'comment',
                        query,
                    ),
                ],
            };
        }

        const records = await db.checklist_run_items.findAll({
            attributes: [ 'id', 'comment' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['comment', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.comment,
        }));
    }

    
};

